import { SerializableItem } from "../serializableitem";

export class GraphElement<JSONType, HistoryType> extends SerializableItem<
    JSONType,
    HistoryType
> {
    constructor(id = -1) {
        super(id);
        this.equals = this.equals.bind(this);
    }

    public isInitialized(): boolean {
        return this.id != -1;
    }

    public toString(): string {
        throw new Error('Function "toString()" has not been implemented.');
    }

    /**
     * Compares two objects. Can be a custom implementation.
     * @returns True, if given object is identical.
     */
    public equals(other: GraphElement<JSONType, HistoryType>): boolean {
        if (other == undefined) {
            return false;
        }

        return other.constructor == this.constructor && other.id == this.id;
    }
}
