export { getClientWidth, getWindowInnerHeight };

/**
 * Returns the maximum width that should be used if displaying elements inside of wordpress.
 * @returns {number}
 */
function getClientWidth(elementId: string): number {
    return document.getElementById(elementId).clientWidth;
}

/**
 * Returns the maximum height that should be used if displaying elements inside of wordpress.
 * @returns {number}
 */
function getWindowInnerHeight(offset = 200): number {
    return window.innerHeight - offset;
}
