import React, { useState } from "react";
import "./spaceselect.css";

interface SpaceSelectProps {
    onLoadSpace: (spaceId: string) => boolean;
    spaces: string[];
    spaceId: string;
}

function SpaceSelect({ onLoadSpace, spaces, spaceId }: SpaceSelectProps) {
    const [selected, setSelected] = useState(spaceId);

    return (
        <div id="spaceselect">
            <select
                onChange={(event) => {
                    setSelected(event.target.value);
                    onLoadSpace(event.target.value);
                }}
                value={selected}
            >
                {spaces.map((spaceName: string) => (
                    <option key={spaceName} value={spaceName}>
                        {spaceName}
                    </option>
                ))}
            </select>
        </div>
    );
}

export default SpaceSelect;
